//+------------------------------------------------------------------+
//|                                              AbrahamTrend_v1.mq4 |
//|                                Copyright  2012, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Red
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 2
#property indicator_width4 3


//---- input parameters
extern int     ATRperiod   = 21; //wATR period
extern double  Kv          =  3; //wATR Multiplier
extern int     AlertMode   =  0; //0-off,1-on
//---- indicator buffers
double UpBuffer[];
double DnBuffer[];
double UpSignal[];
double DnSignal[];
double smin[];
double smax[];
double trend[];
double atr[];

bool     UpTrendAlert=false, DownTrendAlert=false;
double   hClose[2], lClose[2];
datetime prevTime;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
   string short_name;
//---- indicator line
   IndicatorBuffers(8);
   SetIndexBuffer(0,UpBuffer); SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(1,DnBuffer); SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(2,UpSignal); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,159);
   SetIndexBuffer(3,DnSignal); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,159);
   SetIndexBuffer(4,smin); 
   SetIndexBuffer(5,smax);
   SetIndexBuffer(6,trend);
   SetIndexBuffer(7,atr);
//---- name for DataWindow and indicator subwindow label
   short_name="AbrahamTrend_v1.1("+ATRperiod+","+DoubleToStr(Kv,3)+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"UpTrend");
   SetIndexLabel(1,"DnTrend");
   SetIndexLabel(2,"UpSignal");
   SetIndexLabel(3,"DnSignal");
//----
   SetIndexDrawBegin(0,2*ATRperiod);
   SetIndexDrawBegin(1,2*ATRperiod);
   SetIndexDrawBegin(2,2*ATRperiod);
   SetIndexDrawBegin(3,2*ATRperiod);

//----
   return(0);
  }

//+------------------------------------------------------------------+
//| AbrahamTrend_v1                                                  |
//+------------------------------------------------------------------+
int start()
{
   
   int shift,limit, counted_bars = IndicatorCounted();
   
   if (counted_bars >  0)  limit = Bars - counted_bars - 1;
   if (counted_bars <  0)  return(0);
   if (counted_bars == 0)  limit = Bars - ATRperiod - 1; 
     
	for(shift=limit;shift>=0;shift--) 
   {	
   if(Time[shift] != prevTime) {hClose[1] = hClose[0]; lClose[1] = lClose[0]; prevTime = Time[shift];}  
   
   atr[shift]  = iATR(NULL,0,1,shift);
   double volty = LWMA(atr,ATRperiod,shift);
   
      if(shift >= Bars - ATRperiod - 1)
      {
      hClose[0] = Close[shift];
      lClose[0] = Close[shift];
      smin[shift] = hClose[0] - Kv*volty; 
	   smax[shift] = lClose[0] + Kv*volty;
      }   
      else
      {
      hClose[0] = hClose[1];
      lClose[0] = lClose[1];
      
      if(Close[shift] > hClose[0]) hClose[0] = Close[shift]; 
      if(Close[shift] < lClose[0]) lClose[0] = Close[shift];
      
      trend[shift] = trend[shift+1];
	
	   if(Close[shift] > smax[shift+1] && trend[shift+1] <= 0) {trend[shift] =  1; hClose[0] = Close[shift];}
	   if(Close[shift] < smin[shift+1] && trend[shift+1] >= 0) {trend[shift] = -1; lClose[0] = Close[shift];}
	   
	   smin[shift] = hClose[0] - Kv*volty; 
	   smax[shift] = lClose[0] + Kv*volty;
	   
	   UpBuffer[shift] = EMPTY_VALUE;
	   DnBuffer[shift] = EMPTY_VALUE;
	   UpSignal[shift] = EMPTY_VALUE;
	   DnSignal[shift] = EMPTY_VALUE;
	       
         if(trend[shift] > 0) 
         {
         //if(smin[shift] < smin[shift+1]) smin[shift] = smin[shift+1];
         UpBuffer[shift] = smin[shift];
         if(trend[shift+1] != trend[shift]) UpSignal[shift] = UpBuffer[shift];
         }
	  
         if(trend[shift] < 0) 
         {
         //if(smax[shift] > smax[shift+1]) smax[shift] = smax[shift+1];
         DnBuffer[shift] = smax[shift];
         if(trend[shift+1]!= trend[shift]) DnSignal[shift] = DnBuffer[shift];
         }
             
      }	  
	}
//----------   
   string Message;
   if(AlertMode > 0)
   {
      if ( trend[2] < 0 && trend[1] > 0 && Volume[0] > 1 && !UpTrendAlert)
      {
	   Message = " "+Symbol()+" M"+Period()+": Signal for BUY";
	   Alert (Message); 
	   UpTrendAlert = true; DownTrendAlert = false;
	   } 
	 	  
	   if ( trend[2]>0 && trend[1]<0 && Volume[0]>1 && !DownTrendAlert)
	   {
	   Message = " "+Symbol()+" M"+Period()+": Signal for SELL";
	   Alert (Message); 
	   DownTrendAlert = true; UpTrendAlert = false;
	   }
   }	   
	    	         
//----	

	return(0);	
}

// MA_Method=3: LWMA - Linear Weighted Moving Average 
double LWMA(double array[],int per,int bar)
{
   double Sum = 0;
   double Weight = 0;
   
      for(int i = 0;i < per;i++)
      { 
      Weight+= (per - i);
      Sum += array[bar+i]*(per - i);
      }
   if(Weight>0) double lwma = Sum/Weight;
   else lwma = 0; 
   return(lwma);
} 

